/*19:*/
#line 284 "triecode.cw"

/*20:*/
#line 288 "triecode.cw"

#include "trie.h"
#include <stdio.h> 
#include <string.h> 

/*:20*/
#line 285 "triecode.cw"

/*21:*/
#line 295 "triecode.cw"

int is_word(char*w,int len){
int i;
for(i= 0;i<len;++i)
if(!check_char(w[i]))
return 0;
return i;
}

/*:21*//*22:*/
#line 305 "triecode.cw"

int is_punctuation(char c){
switch(c){
case'.':
case',':
case';':
case':':
return 1;
}
return 0;
}

/*:22*//*23:*/
#line 318 "triecode.cw"

int is_quote(char c){
switch(c){
case'\'':
case'"':
case'`':
return 1;
}
return 0;
}

/*:23*//*24:*/
#line 330 "triecode.cw"

#define MAX_WSIZE 64

/*:24*//*25:*/
#line 334 "triecode.cw"

char*adjust_word(char*w){

if(is_quote(*w))w++;
if(is_quote(*w))w++;


int len= strlen(w);
int i;
for(i= 0;i<3&&i<len;++i){
int last= len-i-1;
if(is_quote(w[last])||is_punctuation(w[last]))
w[last]= 0;
}
return w;
}

/*:25*//*26:*/
#line 352 "triecode.cw"

int proc_file(Trie*t,char*file){
FILE*f= fopen(file,"r");
if(!f)
abort("error opening file");
char w[MAX_WSIZE+1];

char format[6];
sprintf(format,"%%%ds",MAX_WSIZE);

for(;;){
if(EOF==fscanf(f,format,w))
break;
char*word= adjust_word(w);
if(is_word(word,strlen(word)))
trie_visit(t,word,1);
}
return 1;
}

/*:26*//*27:*/
#line 373 "triecode.cw"

int main(int argc,char**argv){
Trie*t= trie_new();
if(!t)return 1;
if(argc<2||argc==3&&strcmp(argv[2],"-p")){
printf("usage:\n %s inputFile [-p]\n",argv[0]);
return 1;
}
proc_file(t,argv[1]);
printf("number of words: %d\n",t->n_words);
if(argc==3)
trie_print(t);
return 0;
}

/*:27*/
#line 286 "triecode.cw"

/*:19*/
